<?php
/* Basic request URL */
define('URL', 'csec.api.qcloud.com/v2/index.php');

function sendRequest($url, $method = 'POST')
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    if (false !== strpos($url, "https")) {
        // 证书
        // curl_setopt($ch,CURLOPT_CAINFO,"ca.crt");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    }
    $resultStr = curl_exec($ch);
    $result = json_decode($resultStr, true);

    return $result;
}

/* Generates an available URL */
function makeURL($method, $action, $region, $secretId, $secretKey, $args)
{
    /* Add common parameters */
    $args['Nonce'] = (string)rand(0, 0x7fffffff);
    $args['Action'] = $action;
    $args['Region'] = $region;
    $args['SecretId'] = $secretId;
    $args['Timestamp'] = (string)time();

    /* Sort by key (ASCII order, ascending), then calculate signature using HMAC-SHA1 algorithm */
    ksort($args);
    $args['Signature'] = base64_encode(
        hash_hmac(
            'sha1', $method . URL . '?' . makeQueryString($args, false),
            $secretKey, true
        )
    );

    /* Assemble final request URL */

    return 'https://' . URL . '?' . makeQueryString($args, true);
}

/* Construct query string from array */
function makeQueryString($args, $isURLEncoded)
{
    $arr = array();
    foreach ($args as $key => $value) {
        if (!$isURLEncoded) {
            $arr[] = "$key=$value";
        } else {
            $arr[] = $key . '=' . urlencode($value);
        }
    }
    return implode('&', $arr);
}

/* Demo section */
/* 密钥,请进行替换,密钥申请地址 https://console.qcloud.com/capi  */
define('SECRET_ID', '');
define('SECRET_KEY', '');

function antiFraud($params, $region='gz')
{
    /*
    * 补充用户、行为信息数据,方便我们做更准确的数据模型
    * 协议参考 https://www.qcloud.com/document/product/295/6584
    */
    $url = makeURL('GET', 'AntiFraud', $region, SECRET_ID, SECRET_KEY, $params);
    $result = sendRequest($url);
    return $result;
}

function main() 
{
    $params = array(
        # 基本字段
        'idNumber'              => '1234567890',
        'phoneNumber'           => '0086-13246208548',
        # 可选字段
        'name'                  => '杨二红'
    );
    print_r(antiFraud($params));
}

main();